#include <types.h>

/* Typdefinitionen **********************************************************/

typedef struct { float xyz[3]; } Vector;

/* Strukturdefinitionen *****************************************************/

struct Punkt
{
  Vector        Koordinaten;
  struct Punkt *Next;
};

struct Polygon
{
  int             Anz_Punkte;
  int             Farbe;
  Vector          Normalvektor;
  struct Punkt   *Punkteliste;
  struct Polygon *Next;
};

struct Objekt
{                
  int             Radius;
  struct Polygon *Polygonliste;
};

struct Objekte
{
  char            Typ;
  int             Zaehler;
  int             Distanz;
  Vector          Mittelpunkt;
  struct Objekte *Next;
};

/* Sonstige Definitionen ****************************************************/

#define BORDER_TOP       0
#define BORDER_BOTTOM  159
#define BORDER_LEFT      0
#define BORDER_RIGHT   319
#define bool          BOOL

#define X 0
#define Y 1
#define Z 2

/* Prototypen ***************************************************************/

struct Punkt *MakePunkteliste(Vector V1, Vector V2, Vector V3, Vector V4);
       void   AddPolygon(struct Objekt *Typ, int Anzahl, Vector NV,
                         int Farbe, struct Punkt  *Punkte);
       void   InitKaese();
       void   InitBad();
       void   InitWuerfel();
       void   InitObjects();
       void   InitGlobal();

/* Globale Variablen ********************************************************/

char   Output[10];
int    Direction;
float  DirVect_x, DirVect_y;
Vector MAK, C1, C2, C3, C4; 

struct Objekte *Objektliste;
struct Objekt  *Kaese;
struct Objekt  *Bad;
struct Objekt  *Wuerfel;


